#include <stdio.h>
#include <stdbool.h>
#include <GL/glx.h>
#include "glxclient.h"
#include "glx/clientinfo.c"
#include "glx/glxext.c"

//They don't seem to end up in any library
//int choose_visual(struct glx_config ** configs, int num_configs, const int *attribList, GLboolean fbconfig_style_tags);
//void init_fbconfig_for_chooser(struct glx_config * config, GLboolean fbconfig_style_tags);
//Bool fbconfigs_compatible(const struct glx_config * const a, const struct glx_config * const b);
//int fbconfig_compare(struct glx_config **a, struct glx_config **b);

#include "riftmesahack-copiedfunctions.h"

GLXFBConfig * glXChooseFBConfig(Display * dpy, int screen, const int *attribList, int *nitems) {
  printf("!!PRELOADED!! glXChooseFBConfig\n");
  static int attribs[] =
  {
    GLX_RENDER_TYPE, GLX_RGBA_BIT,
    GLX_DRAWABLE_TYPE, GLX_WINDOW_BIT,
    GLX_DOUBLEBUFFER, true,
    GLX_RED_SIZE, 1,
    GLX_GREEN_SIZE, 1,
    GLX_BLUE_SIZE, 1,
    None
  };

  struct glx_config **config_list;
  int list_size;


  config_list = (struct glx_config **)
    glXGetFBConfigs(dpy, screen, &list_size);

  if ((config_list != NULL) && (list_size > 0) && (attribs != NULL)) {
    list_size = choose_visual(config_list, list_size, attribs, GL_TRUE);
    if (list_size == 0) {
      // free(config_list); //whatever, just leak it
      config_list = NULL;
    }
  }

  *nitems = list_size;
  return (GLXFBConfig *) config_list;

}

int glXQueryContext(Display * dpy, GLXContext ctx_user, int attribute, int *value) {
  printf("!!PRELOADED!! glXQueryContext\n");
  static int attributs[] =     {
    GLX_RENDER_TYPE, GLX_RGBA_BIT,
    GLX_DRAWABLE_TYPE, GLX_WINDOW_BIT,
    GLX_DOUBLEBUFFER, true,
    GLX_RED_SIZE, 1,
    GLX_GREEN_SIZE, 1,
    GLX_BLUE_SIZE, 1,
    None
  };
  struct glx_context *ctx = (struct glx_context *) ctx_user;

  switch (*attributs) {
    case GLX_SHARE_CONTEXT_EXT:
      *value = ctx->share_xid;
      break;
    case GLX_VISUAL_ID_EXT:
      *value = ctx->config ? ctx->config->visualID : None;
      break;
    case GLX_SCREEN:
      *value = ctx->screen;
      break;
    case GLX_FBCONFIG_ID:
      *value = ctx->config ? ctx->config->fbconfigID : None;
      break;
    case GLX_RENDER_TYPE:
      *value = ctx->renderType;
      break;
    default:
      return GLX_BAD_ATTRIBUTE;
  }
  return Success;
}

